/**
 * Pin It
 */
( function( $ ) {

	$.fn.buzzblogproPinIt = function() {

		$( this ).each( function() {

			if ( $( this ).hasClass( 'pinterest-ready' ) ) {
				return;
			}
			var width  = $( this ).attr( 'width' );
			var height = $( this ).attr( 'height' );

			if ( typeof width === 'undefined' ) {
				width = $( this ).width();
			}

			if ( typeof height === 'undefined' ) {
				height = $( this ).height();
			}
			
			if ( !( parseInt( width ) > 120 && parseInt( height ) > 120 ) ) {
				$( this ).addClass( 'pinterest-ready' );
				return;
			}

			var container = $( this ).parent(),
				postURL = $( location ).attr( 'href' ),
				pinURL;

			if ( $( container ).is( 'a' ) ) {

				var imagehref = $( container ).attr( 'href' );

				if ( typeof imagehref !== 'undefined' && imagehref.match( /\.(gif|jpeg|jpg|png)/ ) ) {
					pinURL = imagehref;
				}

				if ( !( $( container ).closest( 'figure' ).length ) ) {
					$( container ).wrap( '<figure class="wrap-pin"></figure>' );
				}

				container = $( container ).parent();

			} else {

				if ( !( $( container ).is( 'figure' ) || $( container ).closest( 'figure' ).length ) ) {
					$( this ).wrap( '<figure class="wrap-pin"></figure>' );
				}

				container = $( this ).parent();

			}

			if ( !$( this ).closest( 'figure' ).hasClass( 'wrap-pin' ) ) {
				$( this ).closest( 'figure' ).addClass( 'wrap-pin' );
			}

			if ( ! pinURL ) {
				if ( $( this ).is( 'img' ) ) {
					pinURL = ( $( this ).hasClass( 'lazyload' ) ) ? $( this ).data( 'src' ) : $( this ).attr( 'src' );
					
				} else {
					pinURL = ( typeof $( container ).find( 'img' ).data( 'src' ) !== 'undefined' ) ? $( container ).find( 'img' ).data( 'src' ) : $( container ).find( 'img' ).attr( 'src' );
				}
			}

			pinURL = encodeURIComponent( pinURL );
			postURL = encodeURIComponent( postURL );

			var figure = container;

			if ( !$( container ).is( 'figure' ) ) {
				figure = $( container ).closest( 'figure' );
			}

			// Get caption text.
			var imgDescription = $( figure ).find( '.wp-caption-text' ).text();

			if ( !imgDescription ) {
				// Get image alt attribute if there's no caption.
				imgDescription = $( figure ).find( 'img' ).attr( 'alt' );
			}

			if ( imgDescription ) {
				// Add attribute to share URL.
				imgDescription = '&amp;description=' + encodeURIComponent( imgDescription );
			}
			
			// Img classes.
			var imgClasses = [ 'alignnone', 'aligncenter', 'alignleft', 'alignright' ];

			imgClasses.forEach( function( el ) {
				if ( $( container ).find( 'img' ).hasClass( el ) ) {
					$( container ).find( 'img' ).removeClass( el );
					$( container ).find( 'img' ).closest( 'figure' ).addClass( el );

					// Add width to figure.
					var imgWidth = $( container ).find( 'img' ).attr( 'width' );

					if ( parseInt( imgWidth ) !== 'NaN' ) {
						$( container ).find( 'img' ).closest( 'figure' ).width( imgWidth );
					}
				}
			} );

			// Add func PintIt.
			var addBuzzblogproPintIt = function( container ) {
				if ( ! $( container ).find( '.pinterest-share-icon' ).length ) {
					$( '<a class="pinterest-share-icon '+buzzblogpro_pinit_localize.iconclass+'" href="https://www.pinterest.com/pin/create/bookmarklet/?url=' + postURL + '&amp;media=' + pinURL + imgDescription + '&is_video=false" target="_blank">'+buzzblogpro_pinit_localize.icon+'</a>' )
						.appendTo( container );
				}
			}

				addBuzzblogproPintIt( container );
			

			$( this ).addClass( 'pinterest-ready' );
		} );
	};


	function initBuzzblogproPinIt() {

		var filterBuzzblogproPinIt = function() {
			var exclude = buzzblogpro_pinit_localize.exclude_selectors;
			if ( exclude ) {
				if ( $( this ).closest( exclude ).length > 0 ) {
					return false;
				}
			}
			return true;
		}

		$( buzzblogpro_pinit_localize.image_selectors ).filter( filterBuzzblogproPinIt ).buzzblogproPinIt();
	
}
	$( document ).ready( function() {
		initBuzzblogproPinIt();
		$(document).on('lazybeforeunveil lazyloaded', function(e){
		 if(e.type == 'lazyloaded'){
		  
		initBuzzblogproPinIt();
		}
		});
	} );
} )( jQuery );